Bug 1016064 - libndp: NDP option decoder issues
libndp: NDP option decoder issues
Status: CLOSED CURRENTRELEASE
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: libndp (Show other bugs)
7.0
Unspecified Unspecified
medium Severity medium
: rc
: ---
Assigned To: Jiri Pirko
Hangbin Liu
:
Depends On:
Blocks: 1016060
  Show dependency treegraph
 
Reported: 2013-10-07 08:31 EDT by Florian Weimer
Modified: 2015-05-04 21:24 EDT (History)
4 users (show)

See Also:
Fixed In Version: libndp-1.2-1.el7
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-06-13 05:41:42 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Florian Weimer 2013-10-07 08:31:11 EDT
In ndp_msg_check_opts() in libndp/libndp.c, this code is used to parse the option header:

		uint8_t cur_opt_raw_type = ptr[0];
		uint8_t cur_opt_len = ptr[1] << 3; /* convert to bytes */

The type of cur_opt_len is incorrect, it should be unsigned, so that large values are not clipped.  With the current code, libndp parsing gets out of sync with the payload and subsequent options are not recognized.

In addition, RFC 2461 requires that packets with zero-length options are silently discarded.  The code merely stops options processing at the first zero-length option.
Comment 2 Florian Weimer 2013-10-07 08:33:58 EDT
ndp_msg_next_opt_offset() has the same problem.
Comment 8 Ludek Smid 2014-06-13 05:41:42 EDT
This request was resolved in Red Hat Enterprise Linux 7.0.

Contact your manager or support representative in case you have further questions about the request.

Note You need to log in before you can comment on or make changes to this bug.